<template>
    <div class="uk-flex uk-flex-center">
        <div class="probleme-container" id="probleme-container" v-if="probleme">
            <TitreProbleme
                :typeExercice="'Choix multiple'"
                :niveau="probleme.getNiveau()"
            />
            <GobanChoixMultiple
                class="uk-margin-small-bottom"
                ref="goban"
                :id="probleme.getId()"
                :situationInitiale="probleme.getSituationInitiale()"
                :marqueursInitiaux="probleme.getMarqueursInitiaux()"
                :solution="probleme.getPossibilites()"
                :position="probleme.getPosition()"
                @afficherCommentaire="demanderMiseAJourCommentaire"
                @envoyerResultat="envoyerResultat"
                @reinitialiser="reinitialiser"
            />
            <transition name="component-fade" mode="out-in">
                <Instructions
                    ref="instructions"
                    :premierCommentaire="probleme.getCommentaire()"
                />
            </transition>

            <div v-for="choix in probleme.getChoix()" :key="choix.getLibelle()">
                <div @click="verifierResultat(choix.getResultat())">
                    <button
                        class="uk-button uk-button-default uk-width-1-1 uk-margin-small-bottom"
                        :disabled="resultatAffiche"
                    >
                        {{ choix.getLibelle() }}
                    </button>
                </div>
            </div>
            <Actions
                :probleme="probleme"
                :isProfilProfesseur="isProfilProfesseur"
            />
        </div>
    </div>
</template>

<script lang="ts">
import Component, { mixins } from 'vue-class-component';
import { Prop } from 'vue-property-decorator';
import GobanChoixMultiple from './GobanChoixMultiple.vue';
import Actions from '../commun/Actions.vue';
import TitreProbleme from '../commun/TitreProbleme.vue';
import Instructions from '../commun/Instructions.vue';
import AffichageProbleme from '../commun/AffichageProbleme.vue';
import ChoixMultiple from '@/classes/ChoixMultiple';
import UIkit from 'uikit';
import Axios from '@/auth/axiosAuth';
import ExperienceUtilisateur from '@/classes/ExperienceUtilisateur';

@Component({
    components: { GobanChoixMultiple, Actions, TitreProbleme, Instructions }
})
export default class AffichageChoixMultiple extends mixins(AffichageProbleme) {
    @Prop() probleme: ChoixMultiple;
    @Prop() isProfilProfesseur: boolean;

    public resultatAffiche = false;

    declare $refs: {
        instructions: Instructions;
        goban: GobanChoixMultiple;
    };

    // mounted() {
    //     const experience: ExperienceUtilisateur = this.$auth.user.getExperience();
    //     if (!experience.getChoixMultiple()) {
    //         UIkit.modal('#' + this.getTitreModal(this.probleme)).show();
    //         Axios.post(
    //             'utilisateur/experience/choixmultiple/' + this.$auth.user.id,
    //             () => (experience.setChoixMultiple(true))
    //         );
    //     }
    // }

    public verifierResultat(resultat: boolean) {
        if (resultat) {
            this.$refs.goban.afficherResultatCorrect();
            this.resultatAffiche = true;
        } else {
            this.$refs.goban.afficherErreur();
        }
    }

    public reinitialiser() {
        this.resultatAffiche = false;
    }

    public getCommentaireInitial(): string {
        return this.probleme.getCommentaire();
    }
}
</script>

<style>
.component-fade-enter-active,
.component-fade-leave-active {
    transition: opacity 0.3s ease;
}
.component-fade-enter,
.component-fade-leave-to {
    opacity: 0;
}
.probleme-container {
    width: 40%;
}

@media screen and (max-width: 540px) {
    .probleme-container {
        width: 80%;
    }
}
</style>
